```
EVTLOG解析
chmod +x myrtle_fw.elog_parser.release_build.csdu5spc38m1.elf
./myrtle_fw.elog_parser.release_build.csdu5spc38m1.elf eventlog_nvme0n1_UD2214C0238M.bin > eventlog_nvme0n1_UD2214C0238M.log

sudo minicom -D /dev/ttyUSB0

lspci -vvv -d cc53:
likun/sfx_tool.py kill_rdt 1 1 1 1

dmesg
ethtool show
sfx-status
./sfx_tool.py mat -h

dmesg -T
sfx-nvme sfx evt-log-dump /dev/nvme4n1 --file eventlog-nvme4n1-UD2214C0255M-0630.bin
tail -n 100 DP_IOWith256K.py_2021-09-22_21-42-10.log

sfx-nvme sfx smart-log-add /dev/nvme3n1

sfx_tool.py upgrade /home/tcn/likun/img/myrtle_fw.asic.wout.bl3.release_build.csdu5spc38m1_U0016678.strip.elf.signed.bin

myrtle_fw/utility/scripts/customer_tools/sfx-status

./sfx_tool.py upgrade /home/tcn/likun/img/myrtle_fw.asic.wout.bl3.dev_build.csdu5spc38m1_U0017101.strip.elf.signed.bin


uname -r

sudo python3 Tool_RandomInjectError.py --errorCount 1
python3 ../samanea/Samanea_Scripts/Tool/Tool_EventLogDump.py --pciPort 60
python3 myrtle_fw/utility/scripts/mat.py
python3 ../samanea/Samanea_Scripts/Tool/Tool_EventLogDump.py --pciPort 87

[root@localhost Tool]# lspci -d cc53:
3b:00.0 Non-Volatile memory controller: Device cc53:0010
3c:00.0 Non-Volatile memory controller: Device cc53:0010
5e:00.0 Non-Volatile memory controller: Device cc53:0010
5f:00.0 Non-Volatile memory controller: Device cc53:0010
60:00.0 Non-Volatile memory controller: Device cc53:0010
61:00.0 Non-Volatile memory controller: Device cc53:0010
86:00.0 Non-Volatile memory controller: Device cc53:0010
87:00.0 Non-Volatile memory controller: Device cc53:0010
89:00.0 Non-Volatile memory controller: Device cc53:0010


sudo nvme fw-download /dev/nvme0n1 --fw=/home/tcn/myrtle_img/myrtle_fw.asic.wout.bl3.dev_build.csdu5spc38c1_vU.0.0@570d55_16008.strip.elf.signed.bin --xfer=0x2000

sudo systemctl enable sshd.service
sudo systemctl start sshd.service
```

```
/home/tcnsh/myrtle_fw/utility/scripts/customer_tools
sudo ./sfx-status 14

[tcnsh@localhost lib]$ sudo python3 sfx_tools_lib.py
--Return--
> /home/tcnsh/myrtle_fw/utility/scripts/customer_tools/lib/sfx_tools_lib.py(1324)<module>()->None
-> pdb.set_trace()
(Pdb) BL3TestOutput(dev='/dev/nvme11n1').showInfo()
BL3TestOutput(dev='/dev/nvme1n1').showInfo()
sfx-nvme sxf  evt-log-dump /dev/nvme0n1  --file eventlog_nvme0n1_UD2214C0238M.bin

sudo sfx-nvme sfx evt-log-dump /dev/nvme0n1 --file=/home/tcn/eventlog.raw
./myrtle_fw.elog_parser.dev_build.csdu5spc38m1.elf eventlog.raw >eventlog.parsed

sudo sfx-nvme sfx smart-log-add /dev/nvme14n1

恢复
sudo sfx-recovery --cmd "cleanCard /dev/nvme0n1"
sudo sfx-recovery --cmd "updateNorImg /dev/nvme0n1 file=/home/tcn/myrtle_fw.asic.union.dev_build.csdu5spc38m1_U2516051.ddr_2933.signed.bin image=255"

使用xscope
[root@localhost scripts]# sudo python2 xscope.py --set_dev=nvme14
Access:/sys/bus/pci/devices/0000\:05:00.0/resource0
>>>Initlize SPI NOR Flash
===Finish SPI NOR initialization
xscope dev name:  nvme14
Access Dev nvme14
Access:/sys/class/nvme/nvme14/device/resource0
>>>Initlize SPI NOR Flash
===Finish SPI NOR initialization
Xscope 0.1.0
Copyright (C) Scaleflux Inc. 2021

xscope>

xscope> h

Documented commands (type help <topic>):
========================================
boots               jlink_write       nor_erase_subsector  reg_set_bit
exit                mat_dbg           nor_program_img      reg_unset_bit
fcelmemdump         ncl2              nor_read_data        set_dev
help                ncl3              nor_write_data       set_slot
jlink_read          ndl2              npt                  shell
jlink_script_read   nid               read                 write
jlink_script_write  nor_erase_sector  read_register

Undocumented commands:
======================
pf

xscope> nor_read_data 0x1fe0000 400
>>>Read 100 words from offset 0x01fe0000
====Nor ReadBack Data:
0x1 0x0 0x1 0x401340 0x0 0x4017c0 0x0 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0x400800 0x0 0x401300 0x0 0xa247269c 0xcdcdcdcd 0xcdcdcdcd 0xabababab 0xabababab 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff 0xffffffff



[root@localhost xscope_myrtle]# pwd
/home/tcn/myrtle_fw/utility/scripts/xscope_myrtle
"xconsole.py"
    def do_nor_read_data(self, args):
        """Read data from nor at offset
           Usage: nor_read_data $offset $len_in_bytes
           eg:    nor_read_data 0x1000000 32
        """
        __args = args.split()
        self.nor.nor_read_data(int(__args[0], 16), int(__args[1]))

xspi_nor.py
    ## Exposed APIs
    def nor_read_data(self, offset=0, size_in_bytes = 4):
        data = []
        if size_in_bytes % 4:
            size = size_in_bytes / 4 + 1
        else:
            size = size_in_bytes / 4
        if self.debug:
            print '>>>Read %d words from offset 0x%08x' %(size, offset)
        if offset & 0x11:
            print "Error: offset has to be 4bytes aligned"


#SPI NOR ACCESS Class
class XSpi_nor:
    def __init__(self, haps=0, debug=0, verbo=0, dev="", slot=""):
        # debug output
        self.debug = 1
        self.verbose = verbo
        self.haps = haps
        self.nor_indirect_rd = 0
        self.nor_erase_max_retry = 3
        self.nor_write_max_retry = 3


```

![image-20220706230829742](C:\Users\wudahht\AppData\Roaming\Typora\typora-user-images\image-20220706230829742.png)

![image-20220706230933747](C:\Users\wudahht\AppData\Roaming\Typora\typora-user-images\image-20220706230933747.png)



![image-20220706232107186](C:\Users\wudahht\AppData\Roaming\Typora\typora-user-images\image-20220706232107186.png)

```
newFWImg: /home/tcnsh/farm/samanea/Samanea_Lib/XScope/U2517164/myrtle_fw.asic.wout.bl3.release_build.csdu5spc76m1_U2517164.strip.elf.signed.bin 
baseFWImg: /home/tcnsh/farm/samanea/Samanea_Lib/XScope/U2517164/myrtle_fw.asic.wout.bl3.release_build.csdu5spc76m1_U2517164.strip.elf.signed.bin

python3 DNLD_BasicFWActiveByResetInNvme.py --newFWImg=/home/tcnsh/b47_img/test.bin --baseFWImg=/home/tcnsh/b47_img/test.bin

panic dump 0x1145000

python3 DNLD_BasicFWActiveByResetInNvme.py --capacityChange=1 --compression=1 --sectorSize=4096 --seed 533591 --newFWImg=/home/tcnsh/b47_img/test.bin

_pf_meta_data_rw_buf_start    = (u8 *)PF_RW_DDR_BUF_START;
_pf_summary_data_rw_buf_start = (u8 *)_pf_meta_data_rw_buf_start + ROUND_UP(PF_FLUSH_META_DATA_SIZE, DATA_LEN_4K);
_pf_root_data_rw_buf_start = (u8 *)_pf_summary_data_rw_buf_start + ROUND_UP(PF_FLUSH_SUMMARY_DATA_SIZE, DATA_LEN_4K);
_pf_padding_data_rw_buf_start = (u8 *)_pf_root_data_rw_buf_start + ROUND_UP(PF_FLUSH_ROOT_DATA_SIZE, DATA_LEN_4K);
_pf_user_data_rw_buf_start    = (u8 *)_pf_padding_data_rw_buf_start + DATA_LEN_4K;

2022-07-05 11:09:58,905 INFO Current script branch is: release/rc_4.2.5
2022-07-05 11:09:58,908 INFO Current script author is: Longfei Zhu
2022-07-05 11:09:58,910 INFO Current script committer is: Zora
2022-07-05 11:09:58,910 INFO Current script committed datetime is: 2022-07-04 10:32:15+08:00
2022-07-05 11:09:58,910 INFO Current script committed hexsha is: 6d5923fcdb5809ed996625bf085cacb7d9095099
2022-07-05 11:09:58,910 INFO Current script summary is: invalid nsid random
2022-07-05 11:09:58,913 INFO DevNum 0 FW build time Jul  1 2022 11:56:53
2022-07-05 11:09:58,913 INFO DevNum 0 FW git origin info git@bitbucket.org:sfxsw/myrtle_fw.git
2022-07-05 11:09:58,913 INFO DevNum 0 FW git branch info HEAD  origin/release/rc_4.2.5  release/rc_4.2.5
2022-07-05 11:09:58,913 INFO DevNum 0 FW git commit info ec3343c87ab7f9bd6efa1c1501312d81978e4545
2022-07-05 11:09:58,913 INFO DevNum 0 FW git author info Jie Zhou <jie.zhou@scaleflux.com>
2022-07-05 11:09:58,913 INFO DevNum 0 FW git time info 2022-07-01 03:37:44 +0000
2022-07-05 11:09:58,913 INFO DevNum 0 FW version info vU.2.5@ec3343_17164
2022-07-05 11:09:58,913 INFO DevNum 0 FW idfy fw version U2517164

=============== Test Summary ==============
Test Case Name:    cap_test
Test Case Execution Time:   0:15:00.379761 (hh:mm:ss.xxxx)
Test Case Result:  Pass


update_footer
```

```
546925 [4-0:0:1D|21:51:48:796]   Backup Capacitance Test Start.

547307 [4-53:3:9D|4:6:37:959]   fw_download_cmd:
547308   > _offset:                0
547309   > _dw_num:              400
547310   > _ctag:                 72
547311   > _act:                  72

552258 [4-53:3:9D|4:6:38:863]   fw_commit_cmd:
552259   > _action:                1
552260   > _slot:                  2
552261   > _ctag:                135
552262   > _act:                 135
552263
552264
552265 [4-53:3:9D|4:6:38:864]   fw_img_info:
552266   > _major_ver:            19
552267   > _minor_ver:          430c
552268   > _build_type:            1
552269   > _bl_type:               3
552270   > _img_len:            2c1258
552271   > _crc32:              b964b7e8
552272   > _opn:                CSDU5SPC76M1
552273   > _compatible_ver:     16893
552274
552275
552276 [4-53:3:9D|4:6:38:892]   rfs_file:

552308 >>> Event Log:  firmware_commit
552309     > old_fw_rev:          NOT-SET
552310     > new_fw_rev:          NOT-SET
552311     > fw_commit_action:    0x1
552312     > fw_slot:             0x2
552313     > status_code_type_for_fw_commit_cmd:   0x0
552314     > status_return_for_fw_commit_cmd:      0x0
552315     > vendor_assigned_fw_commit_result_code:0x0
552316 >>> persistent_evt_loghdr !!!
552317    offset:177168, logid:de
552318
552319 [4-53:3:9D|4:6:39:9]   fw_commit_cpl:
552320   > _ctag:                135
552321   > _act:                 135
552322   > _sct:                   0
552323   > _sc:                    0

552881 [4-53:3:9D|4:6:39:271]   smpstate_change:
552882   > _src_state:          SMP_STATE_FW_ACTIVE
552883   > _tgt_state:          SMP_STATE_PF
552884   > _stage:              SMP_SWITCH_STAGE_START
552885
552886
552887 [4-53:3:9D|4:6:39:271]   smpstate_change:
552888   > _src_state:          SMP_STATE_FW_ACTIVE
552889   > _tgt_state:          SMP_STATE_PF
552890   > _stage:              SMP_SWITCH_STAGE_FINISHED

552986 [4-0:0:1D|0:44:47:94]   boot_status:
552987   > _runmode:            USER_MODE
552988   > _with_ut:            false
552989   > _boot_mode:          CPU_IMMEDIATE_ACTIVE
552990   > _rfs_init_status:       0
552991   > _found_panicdump:       0
552992   > _recovery_mode:      RECOVERY_MODE_PF
552993   > _format_cap_in_GB:       1e00
552994   > _tgt_state:          SMP_STATE_RECOVERY
552995
552996   > power data:            16765144mmW
552997   > board temp:            49degrees celsius
552998   > chip_cpu_drr temp:     59degrees celsius
552999   > chip_serdes temp:      61degrees celsius
553000   > chip_nand1 temp:       57degrees celsius
553001   > chip_nand2 temp:       60degrees celsius
553002   > adc temp:              58degrees celsius

553641 [4-0:0:1D|21:51:51:673]   Backup Capacitance Test Start.

553761 [4-0:0:1D|21:51:51:713]   Raw Data: v_final: 655, v_initial: 652, time: 2889
553762
553763
553764 [4-0:0:1D|21:51:51:713]   Calculated Capacitance -62931 uf.
553765
553766
553767 [4-0:0:1D|21:51:51:713]   Backup Capacitance Test Complete.


0a8eba05b42936cbfa658600807735b89bd9a20b

=============== Test Summary ==============
Test Case Name:    cap_test
Test Case Execution Time:   0:15:28.080640 (hh:mm:ss.xxxx)
Test Case Result:  Pass


EVT_LOG(power_temperature_evtlog);

552996   > power data:            16765144mmW
552997   > board temp:            49degrees celsius
552998   > chip_cpu_drr temp:     59degrees celsius
552999   > chip_serdes temp:      61degrees celsius
553000   > chip_nand1 temp:       57degrees celsius
553001   > chip_nand2 temp:       60degrees celsius
553002   > adc temp:              58degrees celsius


[2022-07-08 14:11:17] [4-0:0:0D|0:0:51:608]   nfe_err:
[2022-07-08 14:11:17]   > _nfe_err_sts:        1000
[2022-07-08 14:11:17]   > _nfe_hw_err_0:          0
[2022-07-08 14:11:17]   > _nfe_hw_err_1:          0
[2022-07-08 14:11:17]   > _nfe_hw_err_2:          0
[2022-07-08 14:11:17]   > _nfe_hw_err_3:          0
[2022-07-08 14:11:17]   > _nfe_status_info:       0
[2022-07-08 14:11:17]   > _nl_err_sts_a:         80
[2022-07-08 14:11:17]   > _nl_err_sts_b:          0


[2022-07-08 14:11:10] [6-0:0:0D|0:0:2:349]   root_data:
[2022-07-08 14:11:10]   > root_data_error_code:    0
[2022-07-08 14:11:10]   > pf_cnt:                 1
[2022-07-08 14:11:10]   > current_pf_sblock:      1
[2022-07-08 14:11:10]   > summary_data_pba:      801340
[2022-07-08 14:11:10]   > last_written_pba:      8017c0
[2022-07-08 14:11:10]   > nor_sub_sector_idx:     0
[2022-07-08 14:11:10]   > user_data_start_pba:   800000
[2022-07-08 14:11:10]   > user_data_end_pba:     8000c0
[2022-07-08 14:11:10]   > parity_data_start_pba:   800100
[2022-07-08 14:11:10]   > parity_data_end_pba:   8001c0
[2022-07-08 14:11:10]   > meta_data_start_pba:   800800
[2022-07-08 14:11:10]   > meta_data_end_pba:     801300

    g_admin_tbl[nvme_opc_firmware_commit]         = &g_commit_cmd;
    g_admin_tbl[nvme_opc_firmware_image_download] = &g_fw_dnld_cmd;
   
bsp_platform::pmic_capacitance_test_request();

        u64 cap_fail = false;
        if (bsp_platform::pmic_capacitance_test_wait(&cap_fail)) {
            if (cap_fail) {
                INF_LOG("Cap Test failed\n");
                softirq::raise_softirq(SOFTIRQ_REQ_SMPSTATE_CHANGE, (u64)SMP_STATE_READONLY);
            } else {
                INF_LOG("Cap Test success!\n");
            }
            INF_LOG("Cap Test FW commit done!\n");
        }

sudo nvme fw-download /dev/nvme0n1 -f /home/tcnsh/b47_img/test.bin -x 0x20000
sudo nvme fw-activate /dev/nvme0n1 -s 1 -a 3


idle_pll_state_evtlog
pll_sys_cpu_to_normal_mode
system_diagnosis

第六排 task_paused=0x00007f7efbdfedb5
011 1111 1011 1111 0111 1101 1110 1111 1111 011 011 011 0101

第四排
00 01 00 01  02 00 03 00  17 01 00 02  02 07 01 04  01 00 00 01  03 0a 00 01  05 00 04 01  00 02 01 01
第五排
00 00 01 00  00 01 00 00  02 06 06 01  00 00 01 04  ff ff ff 03

upgrade cmds
sudo nvme fw-download /dev/nvme0n1 --fw=<bl3 image file> --xfer=0x2000
sudo nvme fw-activate /dev/nvme0n1 --slot=1 --action=1
sudo ipmitool power cycle

0a8eba05b42936cbfa658600807735b89bd9a20b


bool fw_commit_cmd::is_all_cmd_clear(void) {
    if (check_io_clear() && check_folding_clear() && g_life_meter_task.check_life_meter_clear()
        && (g_blk_err_vali_task.check_event_handle_status() == EVENT_HANDLED)
        && (g_trim_backend_task.check_event_handle_status() == EVENT_HANDLED)
        && (g_rfs_file_task.check_event_handle_status() == EVENT_HANDLED)
        && (g_padding_task.check_event_handle_status() == EVENT_HANDLED)
        && (g_trim_frontend_task.check_event_handle_status() == EVENT_HANDLED)
        && (g_maplog_task.check_maplog_clear())
        && (g_footer_task.check_footer_clear(FOOTER_HANDLE_SHUTDOWN))
        && (g_ckp_task.check_event_handle_status() == EVENT_HANDLED)
        && (g_l2p_patch_mgr._flush_request_fifo.count() == 0)) {
        return true;
    }
    return false;
}


commit ca2966228f50520a846ed03cd1257df591c5ea3d (HEAD -> personal/pf_evtlog)
Author: bert <bert.hu@scaleflux.com>
Date:   Fri Jul 22 12:15:47 2022 +0800

    add evtlog when pf dump

commit 75905d930a8ecdc6426dfb4b97c2c72062664a00 (origin/personal/pf_evtlog)
Author: bert <bert.hu@scaleflux.com>
Date:   Wed Jul 20 16:06:19 2022 +0800

    Solve the case when user data flush cnt exceeds PF_MAX_FLUSH_CNT

261659 [6-0:0:0D|0:0:10:778]   partial_block_handle_second_scan:
261660   > start_read_pba:      56533640
261661   > end_read_pba:        56533800


263806 [6-0:0:0D|0:0:10:761]   partial_block_handle_second_scan:
263807   > start_read_pba:      56000000
263808   > end_read_pba:        5656f800

4/1000
4K maplog --> 1M 数据
1M footer --> 4K maplog


void pf_mgr::prepare_evt_log_meta_data()

```

![image-20220708152737414](C:\Users\wudahht\AppData\Roaming\Typora\typora-user-images\image-20220708152737414.png)![image-20220714171429464](C:\Users\wudahht\AppData\Roaming\Typora\typora-user-images\image-20220714171429464.png)![image-20220714171442844](C:\Users\wudahht\AppData\Roaming\Typora\typora-user-images\image-20220714171442844.png)





去掉Idle的状态

\# step 3.1 seq rd 128k/1job/qd1 for 60s

fio --ramp_time=5 --buffer_compress_percentage=54 --buffer_compress_chunk=4k --percentile_list=10:20:30:40:50:60:70:80:90:99:99.9:99.99:99.999:99.9999:99.99999:99.999999:99.9999999 --name=SeqRdBs128Time60 --filename=/dev/nvme0n1 --ioengine=libaio --direct=1 --thread=1 --numjobs=1 --iodepth=1 --rw=read --bs=128k --runtime=60 --time_based=1 --size=100% --group_reporting --log_avg_msec=1000 --bwavgtime=1000 s >> /root/wn/log/seq_rd_comp_bs128k_60s.log

```
union Image Location:

http://192.168.39.7/myrtle-builds/release/rc_4.2.5/vU.2.5@e2dce3_16051/

Union image - An image contains bl2, bl3 and PCIe/DDR Config file.

bl3 image - An image file only contains the bl3 production firmware.
```

